/*++++++++++++++
.IDENTIFICATION compute_qbox.c
.LANGUAGE       C
.AUTHOR         CDS Catalogues Service
.ENVIRONMENT    
.KEYWORDS       
.VERSION  1.0   31-Oct-2003
.COMMENTS       Compute Qboxes for UCAC2
---------------*/

#include <stdlib.h>
#include <stdio.h>
#include <qbox.h>

#define SAMPLER "out.sam"
#define QBOX_LEVEL 8

static char *infile = SAMPLER ;

double atof() ;

main(int argc, char **argv)
{
  FILE *flist ;
  char buf[1024] ;
  int *counts, *u, *e, *c ;
  char *p ;
  double pos[2] ;
  int i, lev, stars ;

    if (argc < 2) {	/* Assumne stdin */
	infile = "-" ;
	flist = stdin ;
    }
    else {
	infile = argv[1] ;
        flist = fopen(infile, "r") ;
    }
    if (!flist) {
	fprintf(stderr, "****") ;
	perror(infile) ;
	exit(1) ;
    }

    /* Read the list of positions */
    stars = 0 ;
    qbox_set(QBOX_LEVEL) ;
    counts = malloc((i = 6<<(QBOX_LEVEL<<1))*sizeof(int)) ;
    memset(counts, 0, i*sizeof(int)) ;
    /* fprintf(stderr, "----10,000 stars: xxxxxx") ; */
    while(fgets(buf, sizeof(buf), flist)) {
	stars++ ;
	for (p = buf; isspace(*p); p++) ;	/* Skip blanks */
	while (isgraph(*p)) p++;		/* Skip $1 ... */
	while (isspace(*p)) p++;		/* $2 = RA+Dec */
	pos[0] = atof(p);	
	for (p+=5; isdigit(*p); p++);
	pos[1] = atof(p);
	if ((stars%50000) == 0) fprintf(stderr, 
		"\r....Stars: %10d Position=%08.4f%+08.4f",
		stars, pos[0], pos[1]) ;
	i = qbox_o(pos) - (9<<(QBOX_LEVEL<<1)) ;
	counts[i] += 1 ;
    }
    /* fclose(flist) ; */
    fprintf(stderr, "\r----Total stars: %d\n", stars) ;

    /* Group the boxes */
    for (lev = QBOX_LEVEL; lev > 0; lev--) {
	i = 9<<(lev<<1) ;
	c = u = counts ;
	e = c + (6<<(lev<<1)) ;
	printf("####level: %d\n", lev) ;
	while (c<e) {
	    if (c[0] && c[1] && c[2] && c[3]) {
		*u = (c[0] + c[1] + c[2] + c[3]) >> 2 ;
		c += 4 ;
		u++;
		continue ;
	    }
	    if (*c) printf("%d d=%d\n", i+(c-counts), *c); c++ ;
	    if (*c) printf("%d d=%d\n", i+(c-counts), *c); c++ ;
	    if (*c) printf("%d d=%d\n", i+(c-counts), *c); c++ ;
	    if (*c) printf("%d d=%d\n", i+(c-counts), *c); c++ ;
	    *u = 0;
	    u++ ;
	}
    }
    /* Write out the list of Qboxes */
    printf("####level: %d\n", lev) ;
    for (i=0; i<6; i++) {
        if (counts[i]) printf("%d d=%d\n", 9+i, counts[i]) ;
    }
    exit(0) ;
}

